## keepassx 2.0.3

=== CMakeLists.txt ===
#  Copyright (C) 2010 Felix Geyer <debfx@fobos.de>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 or (at your option)
#  version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo Debug Debugfull Profile MinSizeRel."
      FORCE)
endif()

project(KeePassX)

cmake_minimum_required(VERSION 2.6.4)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckCXXSourceCompiles)

option(WITH_TESTS "Enable building of unit tests" ON)
option(WITH_GUI_TESTS "Enable building of GUI tests" OFF)
option(WITH_CXX11 "Build with the C++ 11 standard" ON)

set(KEEPASSX_VERSION "2.0.3")
set(KEEPASSX_VERSION_NUM "2.0.3")

if("${CMAKE_C_COMPILER}" MATCHES "clang$" OR "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_COMPILER_IS_CLANG 1)
endif()

if("${CMAKE_CXX_COMPILER}" MATCHES "clang(\\+\\+)?$" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_COMPILER_IS_CLANGXX 1)
endif()

macro(add_gcc_compiler_cxxflags FLAGS)
  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS}")
  endif()
endmacro(add_gcc_compiler_cxxflags)

macro(add_gcc_compiler_cflags FLAGS)
  if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_CLANG)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${FLAGS}")
  endif()
endmacro(add_gcc_compiler_cflags)

macro(add_gcc_compiler_flags FLAGS)
  add_gcc_compiler_cxxflags("${FLAGS}")
  add_gcc_compiler_cflags("${FLAGS}")
endmacro(add_gcc_compiler_flags)

add_definitions(-DQT_NO_KEYWORDS -DQT_NO_EXCEPTIONS -DQT_NO_STL -DQT_STRICT_ITERATORS -DQT_NO_CAST_TO_ASCII)

add_gcc_compiler_flags("-fno-common -fstack-protector --param=ssp-buffer-size=4")
add_gcc_compiler_flags("-Wall -Wextra -Wundef -Wpointer-arith -Wno-long-long")
add_gcc_compiler_flags("-Wformat=2 -Wmissing-format-attribute")
add_gcc_compiler_flags("-fvisibility=hidden")
add_gcc_compiler_cxxflags("-fvisibility-inlines-hidden")

add_gcc_compiler_cxxflags("-fno-exceptions -fno-rtti")
add_gcc_compiler_cxxflags("-Wnon-virtual-dtor -Wold-style-cast -Woverloaded-virtual")
add_gcc_compiler_cflags("-Wchar-subscripts -Wwrite-strings")

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
if (CMAKE_BUILD_TYPE_LOWER MATCHES (release|relwithdebinfo|minsizerel))
  add_gcc_compiler_flags("-D_FORTIFY_SOURCE=2")
endif()

check_c_compiler_flag("-Werror=format-security -Werror=implicit-function-declaration" WERROR_C_AVAILABLE)
check_cxx_compiler_flag("-Werror=format-security" WERROR_CXX_AVAILABLE)
if(WERROR_C_AVAILABLE AND WERROR_CXX_AVAILABLE)
  add_gcc_compiler_flags("-Werror=format-security")
  add_gcc_compiler_cflags("-Werror=implicit-function-declaration")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-align")
endif()

if(CMAKE_COMPILER_IS_GNUCC)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-align")
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--no-add-needed -Wl,--as-needed -Wl,--no-undefined")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-add-needed -Wl,--as-needed")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,relro")
endif()

if (WITH_CXX11)
  add_gcc_compiler_cxxflags("-std=c++0x")
  add_gcc_compiler_cflags("-ansi")
  if(APPLE)
    add_gcc_compiler_cxxflags("-stdlib=libc++")
  endif()
else()
  add_gcc_compiler_flags("-ansi")
endif()

if(MINGW)
  set(CMAKE_RC_COMPILER_INIT windres)
  enable_language(RC)
  set(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
endif()

if(APPLE OR MINGW)
  set(PROGNAME KeePassX)
else()
  set(PROGNAME keepassx)
endif()

if(APPLE AND "${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr/local")
  set(CMAKE_INSTALL_PREFIX "/Applications")
endif()

if(MINGW)
  set(BIN_INSTALL_DIR    ".")
  set(PLUGIN_INSTALL_DIR ".")
  set(DATA_INSTALL_DIR   "share")
elseif(APPLE)
  set(BIN_INSTALL_DIR    ".")
  set(PLUGIN_INSTALL_DIR ".")
  set(DATA_INSTALL_DIR   "${PROGNAME}.app/Contents/Resources")
else()
  include(GNUInstallDirs)

  set(BIN_INSTALL_DIR    "${CMAKE_INSTALL_BINDIR}")
  set(PLUGIN_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/keepassx")
  set(DATA_INSTALL_DIR   "${CMAKE_INSTALL_DATADIR}/keepassx")
endif()

if(WITH_TESTS)
  enable_testing()
endif(WITH_TESTS)

set(QT_REQUIRED_MODULES QtCore QtGui QtTest)

find_package(Qt4 4.6.0 REQUIRED ${QT_REQUIRED_MODULES})
include(${QT_USE_FILE})
# Debian sets the the build type to None for package builds.
# Make sure we don't enable asserts there.
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_NONE QT_NO_DEBUG)

find_package(Gcrypt REQUIRED)
if(NOT (${GCRYPT_VERSION_STRING} VERSION_LESS "1.6.0"))
  message(STATUS "Gcrypt ${GCRYPT_VERSION_STRING} supports the SALSA20 cipher")
  set(GCRYPT_HAS_SALSA20 1)
endif()

find_package(ZLIB REQUIRED)

check_cxx_source_compiles("
  #include <zlib.h>

  #if !defined(ZLIB_VERNUM) || (ZLIB_VERNUM < 0x1200)
      #error zlib 1.2.x or higher is required to use the gzip format
  #endif

  int main() { return 0; }" ZLIB_SUPPORTS_GZIP)

if(NOT ZLIB_SUPPORTS_GZIP)
  message(FATAL_ERROR "zlib 1.2.x or higher is required to use the gzip format")
endif()

if(UNIX)
  check_cxx_source_compiles("#include <sys/prctl.h>
    int main() { prctl(PR_SET_DUMPABLE, 0); return 0; }"
    HAVE_PR_SET_DUMPABLE)

  check_cxx_source_compiles("#include <sys/resource.h>
    int main() {
      struct rlimit limit;
      limit.rlim_cur = 0;
      limit.rlim_max = 0;
      setrlimit(RLIMIT_CORE, &limit);
      return 0;
    }" HAVE_RLIMIT_CORE)

  if(APPLE)
    check_cxx_source_compiles("#include <sys/types.h>
      #include <sys/ptrace.h>
      int main() { ptrace(PT_DENY_ATTACH, 0, 0, 0); return 0; }"
      HAVE_PT_DENY_ATTACH)
  endif()
endif()

include_directories(SYSTEM ${GCRYPT_INCLUDE_DIR} ${ZLIB_INCLUDE_DIR})

if(NOT (${CMAKE_VERSION} VERSION_LESS 2.8.3))
  set(PRINT_SUMMARY ON)
  include(FeatureSummary)
endif()

add_subdirectory(src)
add_subdirectory(share)
add_subdirectory(utils)
if(WITH_TESTS)
  add_subdirectory(tests)
endif(WITH_TESTS)

if(PRINT_SUMMARY)
  feature_summary(WHAT ALL)
endif()

=== tests/CMakeLists.txt ===
#  Copyright (C) 2010 Felix Geyer <debfx@fobos.de>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 or (at your option)
#  version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOURCE_DIR}/src)

add_definitions(-DQT_TEST_LIB)

set(KEEPASSX_TEST_DATA_DIR ${CMAKE_CURRENT_SOURCE_DIR}/data)
configure_file(config-keepassx-tests.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-keepassx-tests.h)

macro(parse_arguments prefix arg_names option_names)
  set(DEFAULT_ARGS)
  foreach(arg_name ${arg_names})
    set(${prefix}_${arg_name})
  endforeach(arg_name)
  foreach(option ${option_names})
    set(${prefix}_${option} FALSE)
  endforeach(option)

  set(current_arg_name DEFAULT_ARGS)
  set(current_arg_list)
  foreach(arg ${ARGN})
    set(larg_names ${arg_names})
    list(FIND larg_names "${arg}" is_arg_name)
    if(is_arg_name GREATER -1)
      set(${prefix}_${current_arg_name} ${current_arg_list})
      set(current_arg_name ${arg})
      set(current_arg_list)
    else()
      set(loption_names ${option_names})
      list(FIND loption_names "${arg}" is_option)
      if(is_option GREATER -1)
        set(${prefix}_${arg} TRUE)
      else(is_option GREATER -1)
        set(current_arg_list ${current_arg_list} ${arg})
      endif()
    endif()
  endforeach(arg)
  set(${prefix}_${current_arg_name} ${current_arg_list})
endmacro(parse_arguments)

macro(add_unit_test)
  parse_arguments(TEST "NAME;SOURCES;MOCS;LIBS" "" ${ARGN})
  set(_test_NAME ${TEST_NAME})
  set(_srcList ${TEST_SOURCES})
  qt4_wrap_cpp(_srcList ${TEST_MOCS})
  add_executable(${_test_NAME} ${_srcList})
  target_link_libraries(${_test_NAME} ${TEST_LIBS})

  if(NOT TEST_OUTPUT)
    set(TEST_OUTPUT plaintext)
  endif(NOT TEST_OUTPUT)
  set(TEST_OUTPUT ${TEST_OUTPUT} CACHE STRING "The output to generate when running the QTest unit tests")

  if(KDE4_TEST_OUTPUT STREQUAL "xml")
    add_test(${_test_NAME} ${_test_NAME} -xml -o ${_test_NAME}.tml)
  else(KDE4_TEST_OUTPUT STREQUAL "xml")
    add_test(${_test_NAME} ${_test_NAME})
  endif(KDE4_TEST_OUTPUT STREQUAL "xml")

  if(NOT MSVC_IDE)   #not needed for the ide
    # if the tests are EXCLUDE_FROM_ALL, add a target "buildtests" to build all tests
    if(NOT WITH_TESTS)
      get_directory_property(_buildtestsAdded BUILDTESTS_ADDED)
      if(NOT _buildtestsAdded)
        add_custom_target(buildtests)
        set_directory_properties(PROPERTIES BUILDTESTS_ADDED TRUE)
      endif()
      add_dependencies(buildtests ${_test_NAME})
    endif()
  endif()
endmacro(add_unit_test)


set(TEST_LIBRARIES
    keepassx_core
    ${QT_QTCORE_LIBRARY}
    ${QT_QTGUI_LIBRARY}
    ${QT_QTTEST_LIBRARY}
    ${GCRYPT_LIBRARIES}
    ${ZLIB_LIBRARIES}
)

set(testsupport_SOURCES modeltest.cpp FailDevice.cpp)
qt4_wrap_cpp(testsupport_SOURCES modeltest.h FailDevice.h)
add_library(testsupport STATIC ${testsupport_SOURCES})

add_unit_test(NAME testgroup SOURCES TestGroup.cpp MOCS TestGroup.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testkeepass2xmlreader SOURCES TestKeePass2XmlReader.cpp MOCS TestKeePass2XmlReader.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testkeys SOURCES TestKeys.cpp MOCS TestKeys.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testkeepass2reader SOURCES TestKeePass2Reader.cpp MOCS TestKeePass2Reader.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testkeepass2writer SOURCES TestKeePass2Writer.cpp MOCS TestKeePass2Writer.h
              LIBS testsupport ${TEST_LIBRARIES})

add_unit_test(NAME testgroupmodel SOURCES TestGroupModel.cpp MOCS TestGroupModel.h
              LIBS testsupport ${TEST_LIBRARIES})

add_unit_test(NAME testentrymodel SOURCES TestEntryModel.cpp MOCS TestEntryModel.h
              LIBS testsupport ${TEST_LIBRARIES})

add_unit_test(NAME testcryptohash SOURCES TestCryptoHash.cpp MOCS TestCryptoHash.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testsymmetriccipher SOURCES TestSymmetricCipher.cpp MOCS TestSymmetricCipher.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testhashedblockstream SOURCES TestHashedBlockStream.cpp MOCS TestHashedBlockStream.h
              LIBS testsupport ${TEST_LIBRARIES})

add_unit_test(NAME testkeepass2randomstream SOURCES TestKeePass2RandomStream.cpp MOCS TestKeePass2RandomStream.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testmodified SOURCES TestModified.cpp MOCS TestModified.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testdeletedobjects SOURCES TestDeletedObjects.cpp MOCS TestDeletedObjects.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testkeepass1reader SOURCES TestKeePass1Reader.cpp MOCS TestKeePass1Reader.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testqsavefile SOURCES TestQSaveFile.cpp MOCS TestQSaveFile.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testwildcardmatcher SOURCES TestWildcardMatcher.cpp MOCS TestWildcardMatcher.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testautotype SOURCES TestAutoType.cpp MOCS TestAutoType.h
              LIBS ${TEST_LIBRARIES})
set_target_properties(testautotype PROPERTIES ENABLE_EXPORTS ON)

add_unit_test(NAME testentry SOURCES TestEntry.cpp MOCS TestEntry.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testqcommandlineparser SOURCES TestQCommandLineParser.cpp MOCS TestQCommandLineParser.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testrandom SOURCES TestRandom.cpp MOCS TestRandom.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testentrysearcher SOURCES TestEntrySearcher.cpp MOCS TestEntrySearcher.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testexporter SOURCES TestExporter.cpp MOCS TestExporter.h
              LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testcsvexporter SOURCES TestCsvExporter.cpp MOCS TestCsvExporter.h
              LIBS ${TEST_LIBRARIES})

if(WITH_GUI_TESTS)
  add_subdirectory(gui)
endif(WITH_GUI_TESTS)

=== utils/CMakeLists.txt ===
#  Copyright (C) 2010 Felix Geyer <debfx@fobos.de>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 or (at your option)
#  version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

include_directories(../src)

add_executable(kdbx-extract kdbx-extract.cpp)
target_link_libraries(kdbx-extract
                      keepassx_core
                      ${QT_QTCORE_LIBRARY}
                      ${QT_QTGUI_LIBRARY}
                      ${GCRYPT_LIBRARIES}
                      ${ZLIB_LIBRARIES})

=== src/autotype/CMakeLists.txt ===
if(Q_WS_X11)
  find_package(X11)
  if(PRINT_SUMMARY)
    add_feature_info(libXi X11_Xi_FOUND "The X11 Xi Protocol library is required for auto-type")
    add_feature_info(libXtst X11_XTest_FOUND "The X11 XTEST Protocol library is required for auto-type")
  endif()

  if(X11_FOUND AND X11_Xi_FOUND AND X11_XTest_FOUND)
    add_subdirectory(x11)
  endif()
endif()

if(WITH_TESTS)
  add_subdirectory(test)
endif()

=== tests/gui/CMakeLists.txt ===
#  Copyright (C) 2011 Felix Geyer <debfx@fobos.de>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 or (at your option)
#  version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_unit_test(NAME testgui SOURCES TestGui.cpp MOCS TestGui.h LIBS ${TEST_LIBRARIES})

add_unit_test(NAME testguipixmaps SOURCES TestGuiPixmaps.cpp MOCS TestGuiPixmaps.h LIBS ${TEST_LIBRARIES})

=== src/autotype/x11/CMakeLists.txt ===
include_directories(SYSTEM ${X11_X11_INCLUDE_PATH})

set(autotype_X11_SOURCES
    AutoTypeX11.cpp
)

set(autotype_X11_MOC
    AutoTypeX11.h
)

qt4_wrap_cpp(autotype_X11_SOURCES ${autotype_X11_MOC})

add_library(keepassx-autotype-x11 MODULE ${autotype_X11_SOURCES})
target_link_libraries(keepassx-autotype-x11 ${QT_QTCORE_LIBRARY} ${QT_QTGUI_LIBRARY} ${X11_X11_LIB} ${X11_Xi_LIB} ${X11_XTest_LIB})
install(TARGETS keepassx-autotype-x11
        BUNDLE DESTINATION . COMPONENT Runtime
        LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR} COMPONENT Runtime)

=== debian/changelog ===
keepassx (2.0.3-4) unstable; urgency=medium

  * New Maintainer. Thanks to Reinhard Tartler! (Closes: #924270)
  * Using new DH level format. Consequently:
       - debian/compat: removed.
       - debian/control: Changed from 'debhelper' to 'debhelper-compat' in
         Build-Depends field and bumped level to 12.
  * debian/control: bumped Standards-Version to 4.4.0.
  * debian/copyright:
       - Include section debian/* copyrights.
       - Update from http to https.
  * debian/patches:
       - Created 10_spell-fix.patch for spell corrections.
       - Created 20_keywords-keepassx-desktop.patch, added "Keywords" section.
       - Modified desktop_file_comment.patch, added description.
  * debian/rules:
       - Updated to provide hardening.
       - Created override some empty directory.
  * debian/tests/control: created to provide a basic trivial test.
  * debian/upstream/metadata: created.
  * debian/upstream/signing-key.asc for only upstream.
  * debian/watch:
       - Updated http to https.
       - Updated version to 4.

 -- Diego Sarzi <diegosarzi@gmail.com>  Sat, 20 Jul 2019 10:59:32 -0300

keepassx (2.0.3-3) unstable; urgency=medium

  * Orphan package, set maintainer to Debian QA Group

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 10 Mar 2019 15:18:52 -0400

keepassx (2.0.3-2) unstable; urgency=medium

  * Acknowledge NMU
  * Bump standards version
  * Improve package description (Thanks to Bruno Kleinert!)

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 12 Jan 2019 12:54:05 -0500

keepassx (2.0.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Support DEB_BUILD_OPTIONS=nocheck based on a patch by
    Helmut Grohne. (Closes: #852368)
  * Set Rules-Requires-Root to "no" as keepassx does not need
    (fake)root.

 -- Niels Thykier <niels@thykier.net>  Sun, 06 Jan 2019 17:35:02 +0000

keepassx (2.0.3-1) unstable; urgency=medium

  * New upstream release. (Closes: #845163)
  * Add missing Comment section to the desktop file. (Closes: #846274)
    - desktop_file_comment.patch

 -- Felix Geyer <fgeyer@debian.org>  Tue, 10 Jan 2017 22:33:14 +0100

=== debian/control ===
Source: keepassx
Section: utils
Priority: optional
Maintainer: Diego Sarzi <diegosarzi@gmail.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libqt4-dev,
               libgcrypt20-dev,
               zlib1g-dev,
               libxtst-dev,
               xvfb,
               xauth
Rules-Requires-Root: no
Standards-Version: 4.4.0
Homepage: https://www.keepassx.org/
Vcs-Git: https://salsa.debian.org/debian/keepassx.git
Vcs-Browser: https://salsa.debian.org/debian/keepassx

Package: keepassx
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Cross Platform Password Manager
 KeePassX is a free/open-source password manager or safe which helps you
 to manage your passwords in a secure way. You can put all your
 passwords in one database, which is locked with one master key or a
 key-disk. So you only have to remember one single master password or
 insert the key-disk to unlock the whole database. The databases are
 encrypted using the algorithms AES or Twofish.
 .
 In contrast to KeePassXC (package keepassxc), the development pace of KeePassX
 has slowed down. It has less features, and uses an outdated version of the Qt
 widget. If you do not know whether you should install keepassx or keepassxc,
 install keepassx instead!

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_GUI_TESTS=ON -DWITH_CXX11=ON

override_dh_auto_test:
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	dh_auto_test -- ARGS+="-E testgui"
	xvfb-run -a --server-args="-screen 0 800x600x24" dh_auto_test -- ARGS+="-R testgui"
endif

override_dh_makeshlibs:
	# keepassx only ships plugins
	dh_makeshlibs -X/usr/lib/$(DEB_HOST_MULTIARCH)/keepassx

override_dh_auto_install:
	dh_auto_install
	# remove empty folders
	find debian/keepassx/usr/share/icons/hicolor/16x16/actions -type d -empty -delete
	find debian/keepassx/usr/share/icons/hicolor/22x22/actions -type d -empty -delete
	find debian/keepassx/usr/share/icons/hicolor/22x22/status -type d -empty -delete

=== debian/tests/control ===
Test-Command: xvfb-run -a keepassx &
Depends: @, xauth, xvfb

## keepassx 2.0.3+git20190121.1682ab9

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 project(KeePassX)
 
-cmake_minimum_required(VERSION 2.6.4)
+cmake_minimum_required(VERSION 2.8.12)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
@@ -31,7 +31,7 @@
 
 option(WITH_TESTS "Enable building of unit tests" ON)
 option(WITH_GUI_TESTS "Enable building of GUI tests" OFF)
-option(WITH_CXX11 "Build with the C++ 11 standard" ON)
+option(WITH_DEV_BUILD "Use only for development. Disables/warns about deprecated methods." OFF)
 
 set(KEEPASSX_VERSION "2.0.3")
 set(KEEPASSX_VERSION_NUM "2.0.3")
@@ -61,7 +61,7 @@
   add_gcc_compiler_cflags("${FLAGS}")
 endmacro(add_gcc_compiler_flags)
 
-add_definitions(-DQT_NO_KEYWORDS -DQT_NO_EXCEPTIONS -DQT_NO_STL -DQT_STRICT_ITERATORS -DQT_NO_CAST_TO_ASCII)
+add_definitions(-DQT_NO_KEYWORDS -DQT_NO_EXCEPTIONS -DQT_STRICT_ITERATORS -DQT_NO_CAST_TO_ASCII)
 
 add_gcc_compiler_flags("-fno-common -fstack-protector --param=ssp-buffer-size=4")
 add_gcc_compiler_flags("-Wall -Wextra -Wundef -Wpointer-arith -Wno-long-long")
@@ -100,14 +100,16 @@
   set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,relro")
 endif()
 
-if (WITH_CXX11)
-  add_gcc_compiler_cxxflags("-std=c++0x")
-  add_gcc_compiler_cflags("-ansi")
-  if(APPLE)
-    add_gcc_compiler_cxxflags("-stdlib=libc++")
-  endif()
-else()
-  add_gcc_compiler_flags("-ansi")
+add_gcc_compiler_cxxflags("-std=c++11")
+
+if(APPLE)
+  add_gcc_compiler_cxxflags("-stdlib=libc++")
+endif()
+
+add_gcc_compiler_cflags("-ansi")
+
+if(WITH_DEV_BUILD)
+  add_definitions(-DQT_DEPRECATED_WARNINGS -DGCRYPT_NO_DEPRECATED)
 endif()
 
 if(MINGW)
@@ -146,19 +148,18 @@
   enable_testing()
 endif(WITH_TESTS)
 
-set(QT_REQUIRED_MODULES QtCore QtGui QtTest)
-
-find_package(Qt4 4.6.0 REQUIRED ${QT_REQUIRED_MODULES})
-include(${QT_USE_FILE})
+find_package(Qt5Core          5.2 REQUIRED)
+find_package(Qt5Concurrent    5.2 REQUIRED)
+find_package(Qt5Widgets       5.2 REQUIRED)
+find_package(Qt5Test          5.2 REQUIRED)
+find_package(Qt5LinguistTools 5.2 REQUIRED)
+set(CMAKE_AUTOMOC ON)
+
 # Debian sets the the build type to None for package builds.
 # Make sure we don't enable asserts there.
-set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS_NONE QT_NO_DEBUG)
-
-find_package(Gcrypt REQUIRED)
-if(NOT (${GCRYPT_VERSION_STRING} VERSION_LESS "1.6.0"))
-  message(STATUS "Gcrypt ${GCRYPT_VERSION_STRING} supports the SALSA20 cipher")
-  set(GCRYPT_HAS_SALSA20 1)
-endif()
+set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS $<$<CONFIG:None>:QT_NO_DEBUG>)
+
+find_package(Gcrypt 1.6.0 REQUIRED)
 
 find_package(ZLIB REQUIRED)
 
@@ -199,10 +200,7 @@
 
 include_directories(SYSTEM ${GCRYPT_INCLUDE_DIR} ${ZLIB_INCLUDE_DIR})
 
-if(NOT (${CMAKE_VERSION} VERSION_LESS 2.8.3))
-  set(PRINT_SUMMARY ON)
-  include(FeatureSummary)
-endif()
+include(FeatureSummary)
 
 add_subdirectory(src)
 add_subdirectory(share)

=== share/CMakeLists.txt ===
#  Copyright (C) 2011 Felix Geyer <debfx@fobos.de>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 or (at your option)
#  version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(translations)

file(GLOB DATABASE_ICONS icons/database/*.png)

install(FILES ${DATABASE_ICONS} DESTINATION ${DATA_INSTALL_DIR}/icons/database)

if(UNIX AND NOT APPLE)
    install(DIRECTORY icons/application/ DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor
            FILES_MATCHING PATTERN "keepassx.png" PATTERN "keepassx.svgz")
    install(DIRECTORY icons/application/ DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor
            FILES_MATCHING PATTERN "application-x-keepassx.png" PATTERN "application-x-keepassx.svgz")
    install(FILES linux/keepassx.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    install(FILES linux/keepassx.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/mime/packages)
endif(UNIX AND NOT APPLE)

if(APPLE)
  install(FILES macosx/keepassx.icns DESTINATION ${DATA_INSTALL_DIR})
endif()

install(DIRECTORY icons/application/ DESTINATION ${DATA_INSTALL_DIR}/icons/application
        FILES_MATCHING PATTERN "*.png" PATTERN "*.svgz")

add_custom_target(icons
                  COMMAND png2icns macosx/keepassx.icns
                    icons/application/16x16/apps/keepassx.png
                    icons/application/32x32/apps/keepassx.png
                    icons/application/48x48/apps/keepassx.png
                    icons/application/128x128/apps/keepassx.png
                    icons/application/256x256/apps/keepassx.png
                  COMMAND icotool -c -o windows/keepassx.ico
                    icons/application/16x16/apps/keepassx.png
                    icons/application/24x24/apps/keepassx.png
                    icons/application/32x32/apps/keepassx.png
                    icons/application/48x48/apps/keepassx.png
                    icons/application/64x64/apps/keepassx.png
                    icons/application/128x128/apps/keepassx.png
                    icons/application/256x256/apps/keepassx.png
                  VERBATIM
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== src/CMakeLists.txt ===
#  Copyright (C) 2010 Felix Geyer <debfx@fobos.de>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 or (at your option)
#  version 3 of the License.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

configure_file(config-keepassx.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-keepassx.h)

include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_HEAD)
git_describe(GIT_DESCRIBE --long)

if (NOT GIT_HEAD OR NOT GIT_DESCRIBE)
    set(GIT_HEAD "")
    set(GIT_DESCRIBE "")
endif()

configure_file(version.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/version.h @ONLY)

set(keepassx_SOURCES
    autotype/AutoType.cpp
    autotype/AutoTypeAction.cpp
    autotype/AutoTypePlatformPlugin.h
    autotype/AutoTypeSelectDialog.cpp
    autotype/AutoTypeSelectView.cpp
    autotype/ShortcutWidget.cpp
    autotype/WildcardMatcher.cpp
    autotype/WindowSelectComboBox.cpp
    autotype/test/AutoTypeTestInterface.h
    core/AutoTypeAssociations.cpp
    core/Config.cpp
    core/Database.cpp
    core/DatabaseIcons.cpp
    core/Endian.cpp
    core/Entry.cpp
    core/EntryAttachments.cpp
    core/EntryAttributes.cpp
    core/EntrySearcher.cpp
    core/FilePath.cpp
    core/Global.h
    core/Group.cpp
    core/InactivityTimer.cpp
    core/ListDeleter.h
    core/Metadata.cpp
    core/PasswordGenerator.cpp
    core/SignalMultiplexer.cpp
    core/TimeDelta.cpp
    core/TimeInfo.cpp
    core/ToDbExporter.cpp
    core/Tools.cpp
    core/Translator.cpp
    core/Uuid.cpp
    crypto/Crypto.cpp
    crypto/CryptoHash.cpp
    crypto/Random.cpp
    crypto/SymmetricCipher.cpp
    crypto/SymmetricCipherBackend.h
    crypto/SymmetricCipherGcrypt.cpp
    format/CsvExporter.cpp
    format/KeePass1.h
    format/KeePass1Reader.cpp
    format/KeePass2.h
    format/KeePass2RandomStream.cpp
    format/KeePass2Reader.cpp
    format/KeePass2Repair.cpp
    format/KeePass2Writer.cpp
    format/KeePass2XmlReader.cpp
    format/KeePass2XmlWriter.cpp
    gui/AboutDialog.cpp
    gui/Application.cpp
    gui/ChangeMasterKeyWidget.cpp
    gui/Clipboard.cpp
    gui/DatabaseOpenWidget.cpp
    gui/DatabaseRepairWidget.cpp
    gui/DatabaseSettingsWidget.cpp
    gui/DatabaseTabWidget.cpp
    gui/DatabaseWidget.cpp
    gui/DatabaseWidgetStateSync.cpp
    gui/DialogyWidget.cpp
    gui/DragTabBar.cpp
    gui/EditWidget.cpp
    gui/EditWidgetIcons.cpp
    gui/EditWidgetProperties.cpp
    gui/FileDialog.cpp
    gui/IconModels.cpp
    gui/KeePass1OpenWidget.cpp
    gui/LineEdit.cpp
    gui/MainWindow.cpp
    gui/MessageBox.cpp
    gui/PasswordEdit.cpp
    gui/PasswordGeneratorWidget.cpp
    gui/PasswordComboBox.cpp
    gui/SettingsWidget.cpp
    gui/SortFilterHideProxyModel.cpp
    gui/UnlockDatabaseWidget.cpp
    gui/WelcomeWidget.cpp
    gui/entry/AutoTypeAssociationsModel.cpp
    gui/entry/EditEntryWidget.cpp
    gui/entry/EditEntryWidget_p.h
    gui/entry/EntryAttachmentsModel.cpp
    gui/entry/EntryAttributesModel.cpp
    gui/entry/EntryHistoryModel.cpp
    gui/entry/EntryModel.cpp
    gui/entry/EntryView.cpp
    gui/group/EditGroupWidget.cpp
    gui/group/GroupModel.cpp
    gui/group/GroupView.cpp
    keys/CompositeKey.cpp
    keys/CompositeKey_p.h
    keys/FileKey.cpp
    keys/Key.h
    keys/PasswordKey.cpp
    streams/HashedBlockStream.cpp
    streams/LayeredStream.cpp
    streams/qtiocompressor.cpp
    streams/StoreDataStream.cpp
    streams/SymmetricCipherStream.cpp
)

set(keepassx_SOURCES_MAINEXE
    main.cpp
)

set(keepassx_FORMS
    gui/AboutDialog.ui
    gui/ChangeMasterKeyWidget.ui
    gui/DatabaseOpenWidget.ui
    gui/DatabaseSettingsWidget.ui
    gui/EditWidget.ui
    gui/EditWidgetIcons.ui
    gui/EditWidgetProperties.ui
    gui/MainWindow.ui
    gui/PasswordGeneratorWidget.ui
    gui/SearchWidget.ui
    gui/SettingsWidgetGeneral.ui
    gui/SettingsWidgetSecurity.ui
    gui/WelcomeWidget.ui
    gui/entry/EditEntryWidgetAdvanced.ui
    gui/entry/EditEntryWidgetAutoType.ui
    gui/entry/EditEntryWidgetHistory.ui
    gui/entry/EditEntryWidgetMain.ui
    gui/group/EditGroupWidgetMain.ui
)

if(MINGW)
  set(keepassx_SOURCES_MAINEXE
      ${keepassx_SOURCES_MAINEXE}
      ${CMAKE_SOURCE_DIR}/share/windows/icon.rc)
endif()

qt5_wrap_ui(keepassx_SOURCES ${keepassx_FORMS})

add_library(keepassx_core STATIC ${keepassx_SOURCES})
set_target_properties(keepassx_core PROPERTIES COMPILE_DEFINITIONS KEEPASSX_BUILDING_CORE)
target_link_libraries(keepassx_core Qt5::Core Qt5::Concurrent Qt5::Widgets)

add_executable(${PROGNAME} WIN32 MACOSX_BUNDLE ${keepassx_SOURCES_MAINEXE})
target_link_libraries(${PROGNAME}
                      keepassx_core
                      Qt5::Core
                      Qt5::Concurrent
                      Qt5::Widgets
                      ${GCRYPT_LIBRARIES}
                      ${ZLIB_LIBRARIES})

set_target_properties(${PROGNAME} PROPERTIES ENABLE_EXPORTS ON)

if(APPLE)
  configure_file(${CMAKE_SOURCE_DIR}/share/macosx/Info.plist.cmake ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
  set_target_properties(${PROGNAME} PROPERTIES
                        MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
endif()

install(TARGETS ${PROGNAME}
        BUNDLE DESTINATION . COMPONENT Runtime
        RUNTIME DESTINATION ${BIN_INSTALL_DIR} COMPONENT Runtime)

add_subdirectory(autotype)

if(APPLE)
  if(QT_MAC_USE_COCOA AND EXISTS "${QT_LIBRARY_DIR}/Resources/qt_menu.nib")
    install(DIRECTORY "${QT_LIBRARY_DIR}/Resources/qt_menu.nib"
            DESTINATION "${DATA_INSTALL_DIR}")
  endif()

  set(CPACK_GENERATOR "DragNDrop")
  set(CPACK_DMG_FORMAT "UDBZ")
  set(CPACK_DMG_VOLUME_NAME "${PROGNAME}")
  set(CPACK_SYSTEM_NAME "OSX")
  set(CPACK_STRIP_FILES ON)
  set(CPACK_PACKAGE_FILE_NAME "${PROGNAME}-${KEEPASSX_VERSION_NUM}")
  include(CPack)

  include(DeployQt4)
  install_qt4_executable(${PROGNAME}.app "qjpeg;qgif;qico;qtaccessiblewidgets")
endif()

if(MINGW )
  set(CPACK_GENERATOR "ZIP")
  set(CPACK_STRIP_FILES ON)
  set(CPACK_PACKAGE_FILE_NAME "${PROGNAME}-${KEEPASSX_VERSION_NUM}")
  include(CPack)

  include(DeployQt4)
  install_qt4_executable(${PROGNAME}.exe "qjpeg;qgif;qico;qtaccessiblewidgets")
endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -52,10 +52,9 @@
 endmacro(parse_arguments)
 
 macro(add_unit_test)
-  parse_arguments(TEST "NAME;SOURCES;MOCS;LIBS" "" ${ARGN})
+  parse_arguments(TEST "NAME;SOURCES;LIBS" "" ${ARGN})
   set(_test_NAME ${TEST_NAME})
   set(_srcList ${TEST_SOURCES})
-  qt4_wrap_cpp(_srcList ${TEST_MOCS})
   add_executable(${_test_NAME} ${_srcList})
   target_link_libraries(${_test_NAME} ${TEST_LIBS})
 
@@ -86,85 +85,80 @@
 
 set(TEST_LIBRARIES
     keepassx_core
-    ${QT_QTCORE_LIBRARY}
-    ${QT_QTGUI_LIBRARY}
-    ${QT_QTTEST_LIBRARY}
+    Qt5::Core
+    Qt5::Concurrent
+    Qt5::Widgets
+    Qt5::Test
     ${GCRYPT_LIBRARIES}
     ${ZLIB_LIBRARIES}
 )
 
 set(testsupport_SOURCES modeltest.cpp FailDevice.cpp)
-qt4_wrap_cpp(testsupport_SOURCES modeltest.h FailDevice.h)
 add_library(testsupport STATIC ${testsupport_SOURCES})
+target_link_libraries(testsupport Qt5::Core Qt5::Concurrent Qt5::Widgets Qt5::Test)
 
-add_unit_test(NAME testgroup SOURCES TestGroup.cpp MOCS TestGroup.h
+add_unit_test(NAME testgroup SOURCES TestGroup.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testkeepass2xmlreader SOURCES TestKeePass2XmlReader.cpp MOCS TestKeePass2XmlReader.h
+add_unit_test(NAME testkeepass2xmlreader SOURCES TestKeePass2XmlReader.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testkeys SOURCES TestKeys.cpp MOCS TestKeys.h
+add_unit_test(NAME testkeys SOURCES TestKeys.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testkeepass2reader SOURCES TestKeePass2Reader.cpp MOCS TestKeePass2Reader.h
+add_unit_test(NAME testkeepass2reader SOURCES TestKeePass2Reader.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testkeepass2writer SOURCES TestKeePass2Writer.cpp MOCS TestKeePass2Writer.h
+add_unit_test(NAME testkeepass2writer SOURCES TestKeePass2Writer.cpp
               LIBS testsupport ${TEST_LIBRARIES})
 
-add_unit_test(NAME testgroupmodel SOURCES TestGroupModel.cpp MOCS TestGroupModel.h
+add_unit_test(NAME testgroupmodel SOURCES TestGroupModel.cpp
               LIBS testsupport ${TEST_LIBRARIES})
 
-add_unit_test(NAME testentrymodel SOURCES TestEntryModel.cpp MOCS TestEntryModel.h
+add_unit_test(NAME testentrymodel SOURCES TestEntryModel.cpp
               LIBS testsupport ${TEST_LIBRARIES})
 
-add_unit_test(NAME testcryptohash SOURCES TestCryptoHash.cpp MOCS TestCryptoHash.h
+add_unit_test(NAME testcryptohash SOURCES TestCryptoHash.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testsymmetriccipher SOURCES TestSymmetricCipher.cpp MOCS TestSymmetricCipher.h
+add_unit_test(NAME testsymmetriccipher SOURCES TestSymmetricCipher.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testhashedblockstream SOURCES TestHashedBlockStream.cpp MOCS TestHashedBlockStream.h
+add_unit_test(NAME testhashedblockstream SOURCES TestHashedBlockStream.cpp
               LIBS testsupport ${TEST_LIBRARIES})
 
-add_unit_test(NAME testkeepass2randomstream SOURCES TestKeePass2RandomStream.cpp MOCS TestKeePass2RandomStream.h
+add_unit_test(NAME testkeepass2randomstream SOURCES TestKeePass2RandomStream.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testmodified SOURCES TestModified.cpp MOCS TestModified.h
+add_unit_test(NAME testmodified SOURCES TestModified.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testdeletedobjects SOURCES TestDeletedObjects.cpp MOCS TestDeletedObjects.h
+add_unit_test(NAME testdeletedobjects SOURCES TestDeletedObjects.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testkeepass1reader SOURCES TestKeePass1Reader.cpp MOCS TestKeePass1Reader.h
+add_unit_test(NAME testkeepass1reader SOURCES TestKeePass1Reader.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testqsavefile SOURCES TestQSaveFile.cpp MOCS TestQSaveFile.h
+add_unit_test(NAME testwildcardmatcher SOURCES TestWildcardMatcher.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testwildcardmatcher SOURCES TestWildcardMatcher.cpp MOCS TestWildcardMatcher.h
-              LIBS ${TEST_LIBRARIES})
-
-add_unit_test(NAME testautotype SOURCES TestAutoType.cpp MOCS TestAutoType.h
+add_unit_test(NAME testautotype SOURCES TestAutoType.cpp
               LIBS ${TEST_LIBRARIES})
 set_target_properties(testautotype PROPERTIES ENABLE_EXPORTS ON)
 
-add_unit_test(NAME testentry SOURCES TestEntry.cpp MOCS TestEntry.h
+add_unit_test(NAME testentry SOURCES TestEntry.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testqcommandlineparser SOURCES TestQCommandLineParser.cpp MOCS TestQCommandLineParser.h
+add_unit_test(NAME testrandom SOURCES TestRandom.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testrandom SOURCES TestRandom.cpp MOCS TestRandom.h
+add_unit_test(NAME testentrysearcher SOURCES TestEntrySearcher.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testentrysearcher SOURCES TestEntrySearcher.cpp MOCS TestEntrySearcher.h
+add_unit_test(NAME testexporter SOURCES TestExporter.cpp
               LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testexporter SOURCES TestExporter.cpp MOCS TestExporter.h
-              LIBS ${TEST_LIBRARIES})
-
-add_unit_test(NAME testcsvexporter SOURCES TestCsvExporter.cpp MOCS TestCsvExporter.h
+add_unit_test(NAME testcsvexporter SOURCES TestCsvExporter.cpp
               LIBS ${TEST_LIBRARIES})
 
 if(WITH_GUI_TESTS)

=== utils/CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,8 @@
 add_executable(kdbx-extract kdbx-extract.cpp)
 target_link_libraries(kdbx-extract
                       keepassx_core
-                      ${QT_QTCORE_LIBRARY}
-                      ${QT_QTGUI_LIBRARY}
+                      Qt5::Core
+                      Qt5::Concurrent
+                      Qt5::Widgets
                       ${GCRYPT_LIBRARIES}
                       ${ZLIB_LIBRARIES})

=== src/autotype/CMakeLists.txt ===
if(UNIX AND NOT APPLE)
  find_package(X11)
  find_package(Qt5X11Extras 5.2)
  add_feature_info(libXi X11_Xi_FOUND "The X11 Xi Protocol library is required for auto-type")
  add_feature_info(libXtst X11_XTest_FOUND "The X11 XTEST Protocol library is required for auto-type")
  add_feature_info(Qt5X11Extras Qt5X11Extras_FOUND "The Qt5X11Extras library is required for auto-type")

  if(X11_FOUND AND X11_Xi_FOUND AND X11_XTest_FOUND AND Qt5X11Extras_FOUND)
    add_subdirectory(xcb)
  endif()
endif()

if(WITH_TESTS)
  add_subdirectory(test)
endif()

=== tests/gui/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,6 @@
 #  You should have received a copy of the GNU General Public License
 #  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-add_unit_test(NAME testgui SOURCES TestGui.cpp MOCS TestGui.h LIBS ${TEST_LIBRARIES})
+add_unit_test(NAME testgui SOURCES TestGui.cpp LIBS ${TEST_LIBRARIES})
 
-add_unit_test(NAME testguipixmaps SOURCES TestGuiPixmaps.cpp MOCS TestGuiPixmaps.h LIBS ${TEST_LIBRARIES})
+add_unit_test(NAME testguipixmaps SOURCES TestGuiPixmaps.cpp LIBS ${TEST_LIBRARIES})

=== src/autotype/xcb/CMakeLists.txt ===
include_directories(SYSTEM ${X11_X11_INCLUDE_PATH})

set(autotype_XCB_SOURCES
    AutoTypeXCB.cpp
)

add_library(keepassx-autotype-xcb MODULE ${autotype_XCB_SOURCES})
target_link_libraries(keepassx-autotype-xcb Qt5::Core Qt5::Widgets Qt5::X11Extras ${X11_X11_LIB} ${X11_Xi_LIB} ${X11_XTest_LIB})
install(TARGETS keepassx-autotype-xcb
        BUNDLE DESTINATION . COMPONENT Runtime
        LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR} COMPONENT Runtime)

=== debian/changelog ===
keepassx (2.0.3+git20190121.1682ab9-2.2) unstable; urgency=medium

  [ Reinhard Tartler ]
  * Non-maintainer upload.

  [ Debian Janitor ]
  * Refer to common license file for CC0-1.0.
  * Update standards version to 4.5.0, no changes needed.

  [ Nis Martensen ]
  * debian/control: recommend keepassxc in description

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 13 Aug 2020 11:55:04 -0400

keepassx (2.0.3+git20190121.1682ab9-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove unused paragraph in copyright file.
  * set XDG_RUNTIME_DIR env in autopkgtest testcase
  * Release 2.0.3+git20190121.1682ab9 from experimental to unstable.

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 11 Sep 2019 02:53:27 +0800

keepassx (2.0.3+git20190121.1682ab9-1) experimental; urgency=medium

  * QA upload.
  * New upstream version 2.0.3+git20190121.1682ab9
  * Replace Qt4 Build-Depends with Qt5 (Closes: #874950)
  * Bump debhelper to 12 and use debhelper-compat
  * Remove WITH_CXX11 option in debian/rules, no longer needed

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 11 Mar 2019 22:45:12 +0800

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,16 @@
 Maintainer: Diego Sarzi <diegosarzi@gmail.com>
 Build-Depends: debhelper-compat (= 12),
                cmake,
-               libqt4-dev,
+               qtbase5-dev,
+               qttools5-dev,
+               libqt5x11extras5-dev,
                libgcrypt20-dev,
                zlib1g-dev,
                libxtst-dev,
                xvfb,
                xauth
 Rules-Requires-Root: no
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Homepage: https://www.keepassx.org/
 Vcs-Git: https://salsa.debian.org/debian/keepassx.git
 Vcs-Browser: https://salsa.debian.org/debian/keepassx
@@ -31,4 +33,4 @@
  In contrast to KeePassXC (package keepassxc), the development pace of KeePassX
  has slowed down. It has less features, and uses an outdated version of the Qt
  widget. If you do not know whether you should install keepassx or keepassxc,
- install keepassx instead!
+ install keepassxc instead!

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DWITH_GUI_TESTS=ON -DWITH_CXX11=ON
+	dh_auto_configure -- -DWITH_GUI_TESTS=ON
 
 override_dh_auto_test:
 ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)

=== debian/tests/control ===
Test-Command: env XDG_RUNTIME_DIR=$(mktemp -d) xvfb-run -a keepassx &
Depends: @, xauth, xvfb

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ \
  https://www.keepassx.org/releases/([\d\.]+)/keepassx-([\d\.]+)\.tar\.(?:bz2|gz|xz)

## keepassx 2.0.3+keepassxc1

=== debian/changelog ===
keepassx (2.0.3+keepassxc1) unstable; urgency=medium

  * QA upload.
  * Orphan package.
  * Replace with transitional package depending on keepassxc, keepassx
    is not active anymore (Closes: #920616)

 -- Julian Andres Klode <jak@debian.org>  Tue, 27 Dec 2022 17:38:52 +0100

=== debian/control ===
Source: keepassx
Section: oldlibs
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 13)
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://www.keepassx.org/
Vcs-Git: https://salsa.debian.org/debian/keepassx.git
Vcs-Browser: https://salsa.debian.org/debian/keepassx

Package: keepassx
Architecture: all
Depends: ${misc:Depends}, keepassxc
Description: Cross Platform Password Manager (empty transitional package)
 This is a transitional package to install the keepassxc package and
 can be safely removed.
 .
 The original keepassx does not receive any further development.
